unit uAdministradorDeEstadosMultiPlano;

{$mode delphi}

interface

uses
  Classes, SysUtils, uEstados, uauxiliares, matreal, xmatdefs,MatEnt,uodt_types;

const
  ARCHI_CFMP = 'C:\basura\CFMP\CF_pruebas.txt';
  VERSION_ARCHI_HIPERPLANOS = '1';

type

  THiperplano = record
    variablesDeEstado,gradiente:TDAofNReal;
    costo:NReal;
  end;

  TDAOfHiperplanos = array of THiperplano;


  TConjuntoDeHiperplanos = record
    dt: TDateTime;
    NHiperplanos:integer;
    hiperPlanos:TDAOfHiperplanos;
  end;

  TDAOfConjuntosDeHiperplanos = array of TConjuntoDeHiperplanos;


  { TAdminEstadosMultiPlano }

  TAdminEstadosMultiPlano = class(TAdminEstados)
    //NFechas:integer;
    NombresVariables:array of string;
    conjuntosDeHiperPlanos:TDAOfConjuntosDeHiperplanos;
    NVariablesDeEstado,kHiperplanoDeMayorCosto,versionArchi:integer;
    fActPaso: NReal;// Q
    archiCFMP:string;
    fsal:TextFile;

    kHiperPlanosFromDts:TVectE;

    dtIniSala,dtFinSala,dtPasoSala:TDateTime;
    nPuntosSala:integer;

    constructor CreateLoadCFMPFromArchi(const archi: string; xDtIniSala,
      xDtFinSala, xDtPasoSala: TDateTime);

    function CreateParasito: TAdminEstadosMultiPlano; override;

    function costoContinuo(kPuntoT: integer): NReal; override;
    function getDtFromKpunto(kPunto:integer):TDateTime;
    function getHiperplanosFromDT(dt:TDateTime):TConjuntoDeHiperplanos;
    function getHiperplanosFromkPunto(kPunto:integer):TConjuntoDeHiperplanos;
    function evaluarHiperplano(hiperplano:THiperplano;estadoR: TDAOfNReal;
    estadoD: TDAOfNInt ):NReal;
    function hiperplanosNulos(dt: TDateTime): TConjuntoDeHiperplanos;
    procedure devxr_continuo(irx: integer; kpuntoT: integer; out dCdx_Inc,
      dCdx_Dec: NReal; out resCod: integer; out xrpos: NReal); override;

    // En principio activa el hiperplano de mayor costo correspondiente al estado
    // actual en kHiperplanoDeMayorCosto
    procedure ActualizarEstadoGlobal(kPaso: integer); override;
    function getkHiperplanosFromDT(dt: TDateTime): Integer;

    procedure WriteToFile(archi:string; variablesDeEstado,coeficientes: array of TMatR;
      hiperplanosPorPaso:Integer);
    procedure WriteEncabHiperplanos(dt:TDateTime;NHiperplanos:Integer);
    procedure WriteHiperplanos(CF_X0:NReal;strVE,strGrad:string);

    procedure Free;

  end;

implementation

{ TAdminEstadosMultiPlano }

constructor TAdminEstadosMultiPlano.CreateLoadCFMPFromArchi(
  const archi: string; xDtIniSala, xDtFinSala, xDtPasoSala: TDateTime);
var
  archiTexto: TextFile;
  str, strVars,strUns, nombre, unidades: string;
  kVariableDeEstado, kFecha,kHiperplano, kPasoSala:integer;
  pHiperplano:^THiperplano;
  pConjuntoDeHiperplanos:^TConjuntoDeHiperplanos;
  maxVal, minVal: NReal;
  NPuntos: Integer;


begin

  if not FileExists(archi) then
    raise exception.Create('no existe el archivo: ' + archi);


  setSeparadoresGlobales;

  archiCFMP:=archi;

  dtIniSala:=xDtIniSala;
  dtFinSala:=xDtFinSala;
  dtPasoSala:=xDtPasoSala;

  nPuntosSala:=round((dtFinSala - dtIniSala)/dtPasoSala) - 1;

  //kHiperPlanosFromDts:=TVectE.Create_Init(nPuntosT);


{  for kPasoSala:=1 to nPuntosT do
    kHiperPlanosFromDts.pon_e(kPasoSala,getkHiperplanosFromDT(dtIniSala +
      (kPasoSala - 1) * dtPasoSala ));     }

  {

  Version_archi_hiperplanos:	1
  fActPaso: 	0.999987063019
  NContinuas:	3
  NDiscretas:	0
  nPuntosT:	2
  -- Descripcion variables continuas --
  Nombre:	Bonete_Vol
  unidades:	Hm3
  NPuntos:	10
  x[..]:	 7.7099999999999992E-009	 1.2000000000000000E+003	 2.3999999999922902E+003	 3.5999999999845804E+003	 4.7999999999768706E+003	 5.9999999999691609E+003	 7.1999999999614511E+003	 8.3999999999537413E+003	 9.5999999999460306E+003	 1.0799999999938320E+004
  Nombre:	Palmar_Vol
  unidades:	Hm3
  NPuntos:	12
  x[..]:	 1.6600000000000001E-009	 1.5500000000000000E+002	 3.0999999999834000E+002	 4.6499999999668000E+002	 6.1999999999502006E+002	 7.7499999999336001E+002	 9.2999999999169995E+002	 1.0849999999900399E+003	 1.2399999999883798E+003	 1.3949999999867198E+003	 1.5499999999850597E+003	 1.7049999999833997E+003
  Nombre:	SG_Vol
  unidades:	Hm3
  NPuntos:	12
  x[..]:	-4.8399999999999998E-010	 1.3900000000000003E+002	 2.7800000000048408E+002	 4.1700000000096810E+002	 5.5600000000145212E+002	 6.9500000000193609E+002	 8.3400000000242017E+002	 9.7300000000290424E+002	 1.1120000000033883E+003	 1.2510000000038724E+003	 1.3900000000043565E+003	 1.5290000000048406E+003
  CF	Bonete_Vol	Palmar_Vol	SG_Vol	dCF/dBonete_Vol	dCF/dPalmar_Vol	dCF/dSG_Vol
  dt:	43250	NHiperplanos:	1
  250	100	200	300	1000	2000	3000
  dt:	43251	NHiperplanos:	2
  251	101	201	301	1001	2001	3001
  252	102	202	302	1002	2002	3002

  }

  AssignFile(archiTexto, archi);
  Reset(archiTexto);
  // al principio tengo que leer toda la informacion del encabezado

  ReadLn(archiTexto, str);
  NextPal(str);// 'Version_archi_hiperplanos:'
  versionArchi := NextInt(str);

  ReadLn(archiTexto, str);
  NextPal(str);// 'fActPaso:'
  fActPaso := NextFloat(str);

  ReadLn(archiTexto, str);
  NextPal(str);// 'NContinuas:'
  nVarsContinuas := NextInt(str);

  ReadLn(archiTexto, str);
  NextPal(str);// 'NDiscretas:'
  nVarsDiscretas := NextInt(str);

  SetLength(xr,nVarsContinuas);
  SetLength(xd,nVarsDiscretas);

  SetLength(xr_def,nVarsContinuas);
  SetLength(xd_def,nVarsDiscretas);


  NVariablesDeEstado:= nVarsContinuas + nVarsDiscretas;


  ReadLn(archiTexto, str);
  NextPal(str);// 'nPuntosT:'
  nPuntosT := NextInt(str);


  if nVarsContinuas > 0 then
  begin
    ReadLn(archiTexto, str); //-- Descripcion variables continuas --
    for kVariableDeEstado:=0 to nVarsContinuas - 1 do
    begin
      ReadLn(archiTexto, str); //Nombre:	Bonete_Vol
      NextPal(str);// 'Nombre:'
      nombre:=NextPal(str);

      ReadLn(archiTexto, str); //unidades:	Hm3
      NextPal(str);// 'unidades:'
      unidades:=NextPal(str);

      ReadLn(archiTexto, str); //NPuntos:	10
      NextPal(str);// 'NPuntos:'
      NPuntos:=NextInt(str);

      ReadLn(archiTexto, str); //x[..]:	 7.7099999999999992E-009	 1.2000000000000000E+003	 2.3999999999922902E+003	 3.5999999999845804E+003	 4.7999999999768706E+003	 5.9999999999691609E+003	 7.1999999999614511E+003	 8.3999999999537413E+003	 9.5999999999460306E+003	 1.0799999999938320E+004
      NextPal(str);// 'x[..]:'
      minVal:=NextFloat(str);
      maxVal:=minVal + (NextFloat(str) - minVal)*(NPuntos - 1 );
      xr_def[kVariableDeEstado]:=TDefVarContinua.Create(nombre,unidades,minVal,maxVal,NPuntos);
    end;
  end;


  if nVarsDiscretas > 0 then
  begin
    ReadLn(archiTexto, str); //-- Descripcion variables continuas --
    for kVariableDeEstado:=0 to nVarsDiscretas - 1 do
    begin
      ReadLn(archiTexto, str); //Nombre:	Bonete_Vol
      NextPal(str);// 'Nombre:'
      nombre:=NextPal(str);

      ReadLn(archiTexto, str); //unidades:	Hm3
      NextPal(str);// 'unidades:'
      unidades:=NextPal(str);

      ReadLn(archiTexto, str); //NPuntos:	10
      NextPal(str);// 'NPuntos:'
      NPuntos:=NextInt(str);

      ReadLn(archiTexto, str); //x[..]:	 7.7099999999999992E-009	 1.2000000000000000E+003	 2.3999999999922902E+003	 3.5999999999845804E+003	 4.7999999999768706E+003	 5.9999999999691609E+003	 7.1999999999614511E+003	 8.3999999999537413E+003	 9.5999999999460306E+003	 1.0799999999938320E+004
      NextPal(str);// 'x[..]:'
      minVal:=NextFloat(str);
      maxVal:=minVal + (NextFloat(str) - minVal)*(NPuntos - 1 );

      xd_def[kVariableDeEstado]:=TDefVarDiscreta.Create(nombre,unidades,NPuntos);
    end;
  end;


  ReadLn(archiTexto, str);// CF X1 X2 X3 dCF/dX1 dCF/X2 dCF/X3

  SetLength(conjuntosDeHiperPlanos,nPuntosT);

  for kFecha:=0 to nPuntosT - 1 do
  begin
    pConjuntoDeHiperplanos:=@conjuntosDeHiperPlanos[kFecha];

    ReadLn(archiTexto, str); // encabezado del conjunto (dt: XXXX NPlanos: XXXX)
    NextPal(str);// 'dt:'
    pConjuntoDeHiperplanos.dt:=NextFloat(str);

    NextPal(str);// 'NHiperplanos:'
    pConjuntoDeHiperplanos.NHiperplanos:=NextInt(str);

    SetLength(pConjuntoDeHiperplanos.hiperPlanos,pConjuntoDeHiperplanos.NHiperplanos);

    for kHiperplano := 0 to pConjuntoDeHiperplanos.NHiperplanos - 1 do
    begin
      pHiperplano:=@pConjuntoDeHiperplanos.hiperPlanos[kHiperplano];

      ReadLn(archiTexto, str); // los valores de la variable y el gradiente

      SetLength(pHiperplano.variablesDeEstado,NVariablesDeEstado);
      SetLength(pHiperplano.gradiente,NVariablesDeEstado);

      pHiperplano.costo:=NextFloat(str);

      for kVariableDeEstado:=0 to NVariablesDeEstado - 1 do
        pHiperplano.variablesDeEstado[kVariableDeEstado]:=NextFloat(str);

      //WriteLn(kFecha);

      for kVariableDeEstado:=0 to NVariablesDeEstado - 1 do
        pHiperplano.gradiente.[kVariableDeEstado]:=NextFloat(str);

    end;
  end;

  CloseFile(archiTexto);

end;

function TAdminEstadosMultiPlano.CreateParasito: TAdminEstadosMultiPlano;
begin
  Result := TAdminEstadosMultiPlano.CreateLoadCFMPFromArchi(archiCFMP,dtIniSala,
    dtFinSala,dtPasoSala);
end;

function TAdminEstadosMultiPlano.costoContinuo(kPuntoT: integer): NReal;
var
  hiperplanos:TConjuntoDeHiperplanos;
  dt:TDateTime;
  kHiperplano:Integer;
  costoMax, costoNuevo:NReal;
  aHiperplano: THiperplano;
begin

  // del conjunto de planos del punto, el que de más grande

  dt:=getDtFromKpunto(kPuntoT);
  hiperplanos:=getHiperplanosFromDT(dt);
  costoMax:=-1E30;
  costoNuevo:=0;

  // El estado tiene que estar definido

  for kHiperplano:=0 to hiperplanos.NHiperplanos - 1 do
  begin
    aHiperplano:=hiperplanos.hiperPlanos[kHiperplano];
    costoNuevo:=evaluarHiperplano(aHiperplano,xr,xd);
    if costoNuevo > costoMax then
      costoMax:=costoNuevo;
  end;

  Result:=costoMax;

end;

function TAdminEstadosMultiPlano.getDtFromKpunto(kPunto: integer): TDateTime;
begin
  Result:=dtIniSala + ( kPunto  - 1 ) * dtPasoSala;
end;

function TAdminEstadosMultiPlano.getHiperplanosFromDT(dt: TDateTime
  ): TConjuntoDeHiperplanos;
var
  kHiperplanos:Integer;
begin

  kHiperplanos:=getkHiperplanosFromDT(dt);

  if kHiperplanos >= 0 then
    Result:=conjuntosDeHiperPlanos[kHiperplanos]
  else
    Result:=hiperplanosNulos(dt);

end;

function TAdminEstadosMultiPlano.getkHiperplanosFromDT(dt: TDateTime): Integer;
var
  kHiperplanos,NConjuntosDeHiperplanos:Integer;
begin

  kHiperplanos:=0;
  NConjuntosDeHiperplanos:=length(conjuntosDeHiperPlanos);

  while (kHiperplanos < NConjuntosDeHiperplanos) and
    (conjuntosDeHiperPlanos[kHiperplanos].dt < dt) do
    Inc(kHiperplanos);

  if kHiperplanos = NConjuntosDeHiperplanos then
    Result:=-1
  else
    Result:=kHiperplanos;
end;

procedure TAdminEstadosMultiPlano.WriteToFile(archi: string; variablesDeEstado,
  coeficientes: array of TMatR; hiperplanosPorPaso: Integer);
var
  kVariable, kPaso, kHiperPlano: Integer;
  dt: TDateTime;
  grad_CF_X0, X0: TVectR;
  A0, CF_X0: NReal;
  strVE, strGrad: String;
begin

  AssignFile(fsal,archi);
  Rewrite(fsal);
  Writeln(fsal, 'Version_archi_hiperplanos:'#9, VERSION_ARCHI_HIPERPLANOS);
  writeln(fsal, 'fActPaso: '#9, FloatToStrF(fActPaso, ffGeneral, 12, 10));
  writeln(fsal, 'NContinuas:', #9, nVarsContinuas);
  writeln(fsal, 'NDiscretas:', #9, nVarsDiscretas);
  writeln(fsal, 'nPuntosT:', #9, nPuntosSala);
  if nVarsContinuas > 0 then
  begin
    writeln(fsal, '-- Descripcion variables continuas --');
    for kVariable := 0 to nVarsContinuas - 1 do
      xr_def[kVariable].PrintToText(fsal);
  end;
  if nVarsDiscretas > 0 then
  begin
    writeln(fsal, '-- Descripcion variables discretas --');
    for kVariable := 0 to nVarsDiscretas - 1 do
      xd_def[kVariable].PrintToText(fsal);
  end;

  write(fsal, 'CF' + #9);

  for kVariable := 0 to nVarsContinuas - 1 do
    write(fsal,xr_def[kVariable].nombre + #9);
  for kVariable := 0 to nVarsDiscretas - 1 do
    write(fsal,xd_def[kVariable].nombre + #9);

  for kVariable := 0 to nVarsContinuas - 1 do
    write(fsal,'dCF/d' + xr_def[kVariable].nombre + #9);
  for kVariable := 0 to nVarsDiscretas - 1 do
    write(fsal,'dCF/d' + xd_def[kVariable].nombre + #9);
  writeLn(fsal);



  // Escribimos los hiperplanos en el archivo de CFMP
  for kPaso:=0 to nPuntosSala  - 1 do
  begin


    dt:=getDtFromKpunto(kPaso + 1);

    WriteEncabHiperplanos(dt,hiperplanosPorPaso);

    //  CF(X0) = A0 + grad(CF(X0))*X0

    for kHiperPlano:=0 to hiperplanosPorPaso -1 do
    begin
      grad_CF_X0:=TVectR.Create_Init(NVariablesDeEstado);
      X0:=TVectR.Create_Init(NVariablesDeEstado);
      //coeficientes[kPaso].WriteArchiXLT('C:\basura\dbg\coeficientes.xlt');
      A0:=coeficientes[kPaso].e(1,kHiperPlano + 1);
      CF_X0 := A0;
      strVE:='';
      strGrad:='';

      for kVariable:=1 to NVariablesDeEstado do
      begin
        grad_CF_X0.pon_e(kVariable,coeficientes[kPaso].e(kVariable+1,kHiperPlano+1) ); //en kVariable=0 esta A0
        X0.pon_e(kVariable,variablesDeEstado[kPaso].e(kVariable,kHiperPlano+1));
        CF_X0 := CF_X0 + grad_CF_X0.e(kVariable)*X0.e(kVariable);
        strVE:=strVE + FloatToStr(X0.e(kVariable)) + #9;
        strGrad:=strGrad + FloatToStr(grad_CF_X0.e(kVariable)) + #9;
      end;

      WriteHiperplanos(CF_X0,strVE,strGrad);

      {
        CF(X) =  CF(X0) + grad(CF(X0))*(X-X0) =

        CF(X) = CF(X0) - grad(CF(X0))*X0  + grad(CF(X0))*X

        CF(X) = A1X1 + A2X2 + A3X3 + A0 ; (A0, A1, A2, A3)

        grad(CF(X0)) = (A1, A2, A3)
        X0 = impresion variables de estado
        CF(X0) = ?
        A0 = CF(X0) - grad(CF(X0))*X0

        CF(X0)= A0 + (A1, A2, A3)*X0
      }

      grad_CF_X0.Free;
      X0.Free;

    end;
  end;

  CloseFile(fsal);

end;



procedure TAdminEstadosMultiPlano.WriteEncabHiperplanos(dt: TDateTime;
  NHiperplanos: Integer);
begin
  writeln(fsal, 'dt:', #9, dt, #9, 'NHiperplanos',  #9, NHiperplanos);
end;

procedure TAdminEstadosMultiPlano.WriteHiperplanos(CF_X0: NReal; strVE,
  strGrad: string);
begin
  writeln(fsal, CF_X0, #9, strVE, strGrad);
end;



procedure TAdminEstadosMultiPlano.Free;
var
  kConjunto, kHiperPlano, kHiperPlanoItem: Integer;
begin

  for kConjunto:=0 to Length(conjuntosDeHiperPlanos)-1 do
  begin
    for kHiperPlano:=0 to Length(conjuntosDeHiperPlanos[kConjunto].hiperPlanos)-1 do
    begin
      SetLength(conjuntosDeHiperPlanos[kConjunto].hiperPlanos[kHiperPlano].gradiente,0);
      SetLength(conjuntosDeHiperPlanos[kConjunto].hiperPlanos[kHiperPlano].variablesDeEstado,0);
    end;
    SetLength(conjuntosDeHiperPlanos[kConjunto].hiperPlanos,0);
  end;
  SetLength(conjuntosDeHiperPlanos,0);

  inherited Free;

end;

function TAdminEstadosMultiPlano.getHiperplanosFromkPunto(kPunto: integer
  ): TConjuntoDeHiperplanos;
var
  dt:TDateTime;
begin
   dt:=getDtFromKpunto(kPunto);
   Result:=getHiperplanosFromDT(dt);
end;

function TAdminEstadosMultiPlano.evaluarHiperplano(hiperplano: THiperplano;
  estadoR: TDAOfNReal; estadoD: TDAOfNInt): NReal;
var
  res:NReal;
  XMenosX0:TDAofNReal;
  kVariableDeEstado:Integer;
begin
  // CF(X) = CF(X0)  + CF'(X0)*(X-X0)
  // paso todo a real
  SetLength(XMenosX0,Length(estadoR) + Length(estadoD));

  // CF(X0)
  res:=hiperplano.costo;

  // X - X0
  for kVariableDeEstado:=0 to Length(estadoR) - 1 do
    XMenosX0[kVariableDeEstado]:=estadoR[kVariableDeEstado] -
      hiperplano.variablesDeEstado[kVariableDeEstado];

  for kVariableDeEstado:=Length(estadoR) to (Length(estadoD) - 1 + Length(estadoR)) do
    XMenosX0[kVariableDeEstado]:=estadoD[kVariableDeEstado - Length(estadoR)] -
      hiperplano.variablesDeEstado[kVariableDeEstado];

  // CF'(X0)*(X - X0) (Producto escalar)
  for kVariableDeEstado:=0 to Length(XMenosX0) - 1 do
  begin
    res:= res  + hiperplano.gradiente[kVariableDeEstado]*XMenosX0[kVariableDeEstado];
  end;

  Result:= res;

end;

function TAdminEstadosMultiPlano.hiperplanosNulos(dt:TDateTime): TConjuntoDeHiperplanos;
var
  conjunto:TConjuntoDeHiperplanos;
  hiperplano:THiperplano;
  kVariableDeEstado:integer;
begin

  hiperplano.costo:=0;
  setlength(hiperplano.gradiente,NVariablesDeEstado);
  setlength(hiperplano.variablesDeEstado,NVariablesDeEstado);

  for kVariableDeEstado:=0 to NVariablesDeEstado - 1 do
  begin
    hiperplano.gradiente[kVariableDeEstado]:=0;
    hiperplano.variablesDeEstado[kVariableDeEstado]:=0;
  end;

  conjunto.NHiperplanos:=1;
  conjunto.dt:=dt;
  setlength(conjunto.hiperPlanos,1);
  conjunto.hiperPlanos[0]:=hiperplano;

  Result:=conjunto;

end;

procedure TAdminEstadosMultiPlano.devxr_continuo(irx: integer;
  kpuntoT: integer; out dCdx_Inc, dCdx_Dec: NReal; out resCod: integer; out
  xrpos: NReal);
var
  hiperplanos:TConjuntoDeHiperplanos;
begin

  hiperplanos:=getHiperplanosFromkPunto(kpuntoT);

  dCdx_Inc:=hiperplanos.hiperPlanos[kHiperplanoDeMayorCosto].gradiente[irx];
  dCdx_Dec:=dCdx_Inc;
  resCod:=0;
  xrpos:=0;

end;

procedure TAdminEstadosMultiPlano.ActualizarEstadoGlobal(kPaso: integer);
var
  hiperplanos: TConjuntoDeHiperplanos;
  NHiperplanos,kHiperplano: Integer;
  costoMAX, costoNuevo:NReal;
  aHiperplano: THiperplano;
begin

  hiperplanos:=getHiperplanosFromkPunto(kPaso);
  NHiperplanos:=hiperplanos.NHiperplanos;

  costoMAX:=-1e20;
  kHiperplanoDeMayorCosto:=-1;
  // calculo el hiperplano más caro para el estado actual
  for kHiperplano:=0 to NHiperplanos - 1 do
  begin
    aHiperplano:=hiperplanos.hiperPlanos[kHiperplano];
    costoNuevo:=evaluarHiperplano(aHiperplano,xr,xd);
    if costoNuevo >= costoMAX then
    begin
      costoMAX:=costoNuevo;
      kHiperplanoDeMayorCosto:=kHiperplano;
    end;
  end;

end;

end.

